/*
** aliasChecks.h
*/

extern alkind alkind_resolve (alkind a1, alkind a2) /*@*/ ;
extern bool checkGlobalDestroyed (sRef fref, fileloc loc) 
   /*@modifies stderr@*/ ;
extern void checkLocalDestroyed (sRef fref, fileloc loc) 
   /*@modifies stderr@*/ ;

extern void checkAssignTransfer (exprNode fexp, exprNode texp);
extern void checkPassTransfer (exprNode fexp, uentry arg, bool isSpec,
			       /*@dependent@*/ exprNode fcn, int argno, int totargs);
extern void checkReturnTransfer (exprNode fexp, uentry rval);
extern void checkGlobReturn (uentry glob);
extern void checkParamReturn (uentry actual);
extern void checkLoseRef (uentry actual);
extern bool canLoseReference (sRef sr, fileloc loc);
extern void checkInitTransfer (exprNode lhs, exprNode rhs);
extern void checkStructDestroyed (sRef fref, fileloc loc);

/* transfer types: */

typedef enum
{
  TT_FCNRETURN,
  TT_DOASSIGN,
  TT_FIELDASSIGN,
  TT_FCNPASS,
  TT_GLOBPASS,
  TT_GLOBRETURN,
  TT_PARAMRETURN,
  TT_LEAVETRANS,
  TT_GLOBINIT,
} transferKind;
