
typedef enum {
  NOCLAUSE,
  TRUECLAUSE,
  FALSECLAUSE,
  ANDCLAUSE,
  ORCLAUSE,
  WHILECLAUSE,
  DOWHILECLAUSE,
  FORCLAUSE,
  CASECLAUSE,
  SWITCHCLAUSE,
  CONDCLAUSE,
  ITERCLAUSE,
  TRUEEXITCLAUSE,
  FALSEEXITCLAUSE
} clause;

extern /*@observer@*/ cstring clause_nameAlternate (clause cl) /*@*/ ;
extern /*@observer@*/ cstring clause_nameTaken (clause cl) /*@*/ ;
extern /*@observer@*/ cstring clause_nameFlip (clause cl, bool filp) /*@*/ ;

extern bool clause_isConditional (clause cl) /*@*/ ;
extern bool clause_isBreakable (clause cl) /*@*/ ;
extern bool clause_isLoop (clause cl) /*@*/ ;
extern bool clause_isSwitch (clause cl) /*@*/ ;
extern bool clause_isCase (clause cl) /*@*/ ;
extern bool clause_isNone (clause cl) /*@*/ ;

extern /*@observer@*/ cstring clause_unparse (clause cl) /*@*/ ;
