/*
** Copyright (c) Massachusetts Institute of Technology 1994, 1995, 1996.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. This code may not be re-distributed or modified
**        without permission from MIT (contact 
**        lclint-request@larch.lcs.mit.edu.)  
**
**        Modification and re-distribution are encouraged,
**        but we want to keep track of changes and
**        distribution sites.
*/
/*
** exprChecks.h
*/

extern bool anyAbstract (ctype c1, /*@sef@*/ ctype c2);
# define anyAbstract(c1, c2) \
  (ctype_isRealAbstract(c1) || ctype_isRealAbstract(c2))

extern void exprNode_checkAllMods (sRefSet mods, uentry ue);
extern void exprNode_checkCallModifyVal (sRef s, exprNodeList args, exprNode f, exprNode err);
extern void exprChecks_checkEmptyMacroBody (void);
extern void exprChecks_checkExport (uentry e);
extern void exprNode_checkFunction (uentry hdr, /*@only@*/ exprNode body);
extern void exprNode_checkFunctionBody (exprNode body);
extern void exprNode_checkIterBody (/*@only@*/ exprNode body);
extern void exprNode_checkIterEnd (/*@only@*/ exprNode body);
extern void exprNode_checkMacroBody (/*@only@*/ exprNode e);
extern void exprNode_checkModify (exprNode e, exprNode err);
extern void exprNode_checkModifyVal (exprNode e, exprNode err);
extern void exprChecks_checkNullReturn (fileloc loc);
extern void exprNode_checkPred (cstring c, exprNode e);
extern void exprNode_checkReturn (exprNode e);
extern void exprNode_checkStatement (exprNode e);
extern void exprChecks_checkUsedGlobs (globSet decl, globSet used);

