/*
** Copyright (c) Massachusetts Institute of Technology 1994, 1995, 1996.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. This code may not be re-distributed or modified
**        without permission from MIT (contact 
**        lclint-request@larch.lcs.mit.edu.)  
**
**        Modification and re-distribution are encouraged,
**        but we want to keep track of changes and
**        distribution sites.
*/
# ifndef lslOpLIST_H
# define lslOpLIST_H

typedef /*@exposed@*/ lslOp e_lslOp;

abst_typedef struct _lslOpList
{
  int nelements;
  int nspace;
  /*@reldef@*/ /*@only@*/ /*@relnull@*/ e_lslOp *elements;
} *lslOpList ;

extern /*@only@*/ lslOpList lslOpList_new(void);
extern void lslOpList_add (lslOpList s, /*@exposed@*/ lslOp el) ;

extern /*@unused@*/ /*@only@*/ cstring lslOpList_unparse (lslOpList s) ;
extern void lslOpList_free (/*@only@*/ lslOpList s) ;

/*@constant int lslOpListBASESIZE;@*/
# define lslOpListBASESIZE SMALLBASESIZE
# else
# error "Multiple include"
# endif




