/*
** Copyright (c) Massachusetts Institute of Technology 1994, 1995, 1996.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. This code may not be re-distributed or modified
**        without permission from MIT (contact 
**        lclint-request@larch.lcs.mit.edu.)  
**
**        Modification and re-distribution are encouraged,
**        but we want to keep track of changes and
**        distribution sites.
*/

typedef enum {
  PRIV_CONST, PRIV_VAR, 
  PRIV_TYPE, PRIV_FUNCTION 
  } privateKind;

typedef struct _privateNode {
  privateKind kind;
  union {
    constDeclarationNode constdeclaration;
    varDeclarationNode vardeclaration;	
    typeNode type;
    fcnNode fcn;
  } content;
} *privateNode;

extern /*@unused@*/ /*@only@*/ cstring privateNode_unparse(privateNode n);
